routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

// Admin routes
Route::name('admin.')->prefix('admin')->namespace('Admin')->group(function () {
    Route::namespace('Auth')->middleware('guest:admin')->group(function () {
        // Login
        Route::get('/', 'LoginController@showLoginForm')->name('login');
        Route::post('/', 'LoginController@login');

        // Forget and reset Password
        Route::get('forgot-password', 'ForgotPasswordController@showLinkRequestForm')->name('forgot_password');
        Route::post('forgot-password', 'ForgotPasswordController@sendResetLinkEmail');
        Route::get('password/reset/{token}/{email?}', 'ResetPasswordController@showResetForm')->name('reset_password_link');
        Route::post('password/reset', 'ResetPasswordController@reset')->name('reset_password');
    });

    // Logged in admin user required
    Route::group(['middleware' => 'auth:admin'], function () {
        // Dashboard
        Route::get('/dashboard', 'AdminController@dashboard')->name('dashboard');

        Route::resource('students', 'StudentController');

        Route::resource('teachers', 'TeacherController');

        Route::resource('subjects', 'SubjectController');

        Route::resource('departments', 'DepartmentController');

        Route::resource('specialties', 'SpecialtyController');

        Route::resource('genders', 'GenderController');

        Route::resource('nationalities', 'NationalityController');

        // Profile
        Route::get('/profile', 'AdminController@profile')->name('profile');
        Route::post('/profile', 'AdminController@profileUpdate');
        Route::post('/password', 'AdminController@passwordUpdate')->name('password_update');

        // Logout
        Route::get('/logout', 'Auth\LoginController@logout')->name('logout');
    });
});

app/Specialty.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Specialty extends Model
{
    use SoftDeletes;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name'
    ];

    /**
     * Validation rules
     *
     * @return array
     **/
    public static function validationRules()
    {
        return [
            'name' => 'required|string',
        ];
    }

    /**
     * Get the teachers for the Specialty.
     */
    public function teachers()
    {
        return $this->hasMany('App\Teacher');
    }

    /**
     * Returns the paginated list of resources
     *
     * @return \Illuminate\Pagination\Paginator
     **/
    public static function getList()
    {
        return static::paginate(10);
    }
}

app/Http/Controllers/Admin/SpecialtyController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Specialty;
use App\Http\Controllers\Controller;

class SpecialtyController extends Controller
{
    /**
     * Display a list of Specialties.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $specialties = Specialty::getList();

        return view('admin.specialties.index', compact('specialties'));
    }

    /**
     * Show the form for creating a new Specialty
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.specialties.add');
    }

    /**
     * Save new Specialty
     *
     * @return \Illuminate\Http\RedirectResponse
     */
    public function store()
    {
        $validatedData = request()->validate(Specialty::validationRules());

        $specialty = Specialty::create($validatedData);

        return redirect()->route('admin.specialties.index')->with([
            'type' => 'success',
            'message' => 'Specialty added'
        ]);
    }

    /**
     * Show the form for editing the specified Specialty
     *
     * @param \App\Specialty $specialty
     * @return \Illuminate\Http\Response
     */
    public function edit(Specialty $specialty)
    {
        return view('admin.specialties.edit', compact('specialty'));
    }

    /**
     * Update the Specialty
     *
     * @param \App\Specialty $specialty
     * @return \Illuminate\Http\RedirectResponse
     */
    public function update(Specialty $specialty)
    {
        $validatedData = request()->validate(
            Specialty::validationRules($specialty->id)
        );

        $specialty->update($validatedData);

        return redirect()->route('admin.specialties.index')->with([
            'type' => 'success',
            'message' => 'Specialty Updated'
        ]);
    }

    /**
     * Delete the Specialty
     *
     * @param \App\Specialty $specialty
     * @return void
     */
    public function destroy(Specialty $specialty)
    {
        if ($specialty->teachers()->count()) {
            return redirect()->route('admin.specialties.index')->with([
                'type' => 'error',
                'message' => 'This record cannot be deleted as there are relationship dependencies.'
            ]);
        }

        $specialty->delete();

        return redirect()->route('admin.specialties.index')->with([
            'type' => 'success',
            'message' => 'Specialty deleted successfully'
        ]);
    }
}

resources/views/admin/specialties/add.blade.php
@extends('admin.layouts.app', ['page' => 'specialty'])

@section('title', 'Add New Specialty')

@section('content')

<div class="x_title">
    <h2>Add New Specialty</h2>

    <div class="clearfix"></div>
</div>

<br>

<form role="form" method="POST" action="{{ route('admin.specialties.store') }}">
    @csrf

    <div class="box-body">
        <div class="form-group">
            <label for="name">Name</label>
            <input type="text"
                class="form-control"
                name="name"
                required
                placeholder="Name"
                value="{{ old('name') }}"
                id="name"
            >
        </div>
    </div>

    <div class="box-footer">
        <button type="submit" class="btn btn-primary">Submit</button>

        <a href="{{ route('admin.specialties.index') }}" class="btn btn-default">
            Cancel
        </a>
    </div>
</form>
@endsection

resources/views/admin/specialties/edit.blade.php
@extends('admin.layouts.app', ['page' => 'specialty'])

@section('title', 'Edit Specialty')

@section('content')
<div class="x_title">
    <h2>Edit Specialty</h2>

    <div class="clearfix"></div>
</div>

<form role="form" method="POST" action="{{ route('admin.specialties.update', ['specialty' => $specialty->id]) }}">
    @csrf
    @method('PUT')

    <div class="box-body">
        <div class="form-group">
            <label for="name">Name</label>
            <input type="text"
                class="form-control"
                name="name"
                required
                placeholder="Name"
                value="{{ old('name', $specialty->name) }}"
                id="name"
            >
        </div>
    </div>

    <div class="box-footer">
        <button type="submit" class="btn btn-primary">Update</button>

        <a href="{{ route('admin.specialties.index') }}" class="btn btn-default">
            Cancel
        </a>
    </div>
</form>
@endsection

resources/views/admin/specialties/index.blade.php
@extends('admin.layouts.app', ['page' => 'specialty'])

@section('title', 'Specialties')

@section('content')
<div class="x_title">
    <h2>Specialties</h2>

    <a class="pull-right btn btn-primary"
        href="{{ route('admin.specialties.create') }}"
    >
        Add New
    </a>

    <div class="clearfix"></div>
</div>

<br>

<div class="box-body">
    <table class="table table-bordered">
        <tr>
            <th>#</th>
            <th>Name</th>
            <th>Action</th>
        </tr>

        @forelse ($specialties as $specialty)
            <tr>
                <td>{{ $specialty->id }}</td>
                <td>{{ $specialty->name }}</td>
                <td>
                    <a href="{{ route('admin.specialties.edit', ['specialty' => $specialty->id]) }}">
                        <i class="fa fa-pencil-square-o"></i>
                    </a>

                    <form action="{{ route('admin.specialties.destroy', ['specialty' => $specialty->id]) }}"
                        method="POST"
                        class="inline pointer"
                    >
                        @csrf
                        @method('DELETE')

                        <a onclick="if (confirm('Are you sure?')) { this.parentNode.submit() }">
                            <i class="fa fa-trash-o"></i>
                        </a>
                    </form>
                </td>
            </tr>
        @empty
            <tr>
                <td colspan="3">No records found</td>
            </tr>
        @endforelse
    </table>
</div>

<div class="box-footer clearfix">
    {{ $specialties->links('vendor.pagination.default') }}
</div>
@endsection